/*******************(abc914-18857a.c)***
 *  SDJ[h̓ǂݏ@@@[ǔ]
 * @iEUSART荞ݗLj
 ***************************************/
#include "mcc_generated_files/mcc.h"
#include <stdio.h>

//--- File Systme@ϐ
FRESULT  result;                    // FatFs
FATFS    drive;                     // t@CsysIuWFNg
FIL      file;                      // t@C\
		
//--- Avϐ
char     FilNam[13] = "LOGDATA.TXT";
uint16_t Length[2];                 // Mpi[z
char     Buffer[80];                // f[^Mpobt@[
char     Msg[40];                   // RgMp
uint8_t  tFlag;                     // ^C}[tO
uint16_t Counter;                   // ^C}[JE^

/***************************************
 *  ^C}0 Callback֐ (1b荞)
 ***************************************/
void TMR0_Process(void){
    tFlag = 1;                      // tOZbg
}

/***************************************
 *  obt@o͊֐
 ***************************************/
void StrWrite(char * str){
    while(*str != 0){               // '\0'(Ij܂ŌJԂ
        EUSART_Write(*str++);       // 1obt@ɏo(Mj
    }
}
//--- EUSART֕񑗐Mistj
void US_Puts(char * str){
    StrWrite(str);
    EUSART_Write('\n');
}

/***************************************
 *  SDJ[hpėp֐
 ***************************************/
//--- SDJ[h̃}Eg
FRESULT SD_Mount(){
    uint8_t i = 0;
    FRESULT res;
    do{
        res = f_mount(&drive,"0:",1);     
        i++;
        EUSART_Write('-');
    }while((res != FR_OK) && (i < 10));    // 10܂Ŏ݂
    
    if(res != FR_OK){                      // }EgsȂ
        US_Puts("** SD Not Mounted !!");
    }else{
        US_Puts("SD Mount OK!");
        LED_SetHigh();
//        __delay_ms(100);
    }
    return res;	
}
//--- SDJ[h̃N[YƃA}Eg
void SD_All_Close(){
    f_close(&file);                         // t@CN[Y
    f_mount(0, "0:", 0);                    // A}Eg
    US_Puts("closed & Un_Mounted"); 
    LED_SetLow();	
}

/***************************************
 *  R}h
 ***************************************/
//--- SDJ[heXgR}h@(ev[gj
void SD_cmd_T(){
    US_Puts("Start Command T");
    if(SD_Mount() == FR_OK){                // SD}Eg
    //  set custom function  ------   
        __delay_ms(2000);
    //  ---------------------------   ̊ԂɃ[UvOLq
        f_mount(0, "0:", 0);                // A}Eg
        US_Puts("Un_Mounted");
    }
    LED_SetLow();
}
//--- SDJ[hǍR}h
void SD_cmd_R(){
    FRESULT res;
    US_Puts("Start Command R");
    if(SD_Mount() == FR_OK){
        res = f_open(&file, FilNam, FA_READ);       // t@CI[v
        if(res == FR_OK){
            sprintf(Msg,"Open %s",FilNam);
            US_Puts(Msg);
            do{
                f_read(&file, Buffer, 64, (UINT *)Length); // SDǍ
                Buffer[Length[0]] = 0;
                US_Puts(Buffer);
            }while(Length[0]!=0);
        }else{
            sprintf(Msg,"** Can't open %s !!",FilNam);
            US_Puts(Msg);           
        }
        SD_All_Close();             // t@CN[Y&A}Eg
    }
//    LED_SetLow();
}
//--- SDJ[hփf[^R}h
void SD_cmd_W(){
    FRESULT res;
    US_Puts("Start Command W");
    if(SD_Mount() == FR_OK){
        res = f_open(&file, FilNam, FA_WRITE | FA_OPEN_APPEND); // t@CI[v
        if(res == FR_OK){
            sprintf(Msg,"Open %s",FilNam);
            US_Puts(Msg);
            sprintf(Msg, "%07d,", Counter);
            f_write(&file, Msg, 8, (UINT *)Length);   // SD֏
            US_Puts(Msg);
        }else{
            sprintf(Msg,"** Can't open %s !!",FilNam);
            US_Puts(Msg);           
        }
        SD_All_Close();       // t@CN[Y&A}Eg
    }
//    LED_SetLow();
}

/***************************************
 *  C֐
 ***************************************/
void main(void){
    uint8_t tMode = 0;                  // ^C}JE^\[htO
    char   cmd;                         // MR}h
    
    SYSTEM_Initialize();
  // ^C}0 Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    
    US_Puts("\n==== SD Test ====");
    
  // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
  //======= C[v =========
    while(1){
      // 1b̏
        if(tFlag == 1){                                 // tOȈꍇ
             LED_Toggle();
            tFlag = 0;                                  // tOZbg
            if(tMode == 0){
                sprintf(Msg,"Counter = %05d",Counter++);   // JEglҏW
                US_Puts(Msg);                           // M
            }
        }
        // R}h
        if(EUSART_is_rx_ready()){                       // M̏ꍇ
            cmd = EUSART_Read();                        // 1M
            sprintf(Msg,"Input = %c\n",cmd);
            US_Puts(Msg);
            switch(cmd){
                case 'T':   SD_cmd_T();  break;         // SD}EgeXg
                case 'R':   SD_cmd_R();  break;         // SDf[^Ǐo
                case 'W':   SD_cmd_W();  break;         // SDɃf[^
                case 'X':   tMode = 1;   break;         // JE^\OFF
                case 'C':   tMode = 0;   break;         // JE^\ON
                default:    US_Puts("???"); break; 
            }
        }
    }
}
/******  End of File ******/
